{ Created: 2001-11-20 by Berend de Boer <berend@pobox.com>
  
  See http://www.pobox.com/~berend/delphi for updates.


  Enhanced TMemoryStream:
  - allocates larger blocks
  - accepts WideStrings

}



unit smart_mem;

interface

uses
  Classes;

type
  TSmartMemoryStream = class(TMemoryStream)
  protected
    function GetDataString: WideString;
    function Realloc(var NewCapacity: Longint): Pointer; override;
  public
    procedure WriteString(const AString: WideString);
    property DataString: WideString read GetDataString;
  end;


const
  cMemoryDelta: integer = 1024 * 1024; // must be power of 2


implementation


{ TSmartMemoryStream }

function TSmartMemoryStream.GetDataString: WideString;
const
  endchar: WideChar = #0;
begin
  if PWideChar(Memory)[Size-1] <> endchar then
    Write(endchar, SizeOf(endchar));
  Result := PWideChar(Memory);
end;


function TSmartMemoryStream.Realloc(var NewCapacity: Integer): Pointer;
begin
  Result := Memory;
  if (NewCapacity > Capacity) or (NewCapacity = 0) then
  begin
    if (NewCapacity <> 0) then
      Inc(NewCapacity, cMemoryDelta);
    Result := inherited Realloc(NewCapacity);
  end;
end;


procedure TSmartMemoryStream.WriteString(const AString: WideString);
begin
  if AString <> '' then
    Write(AString[1], length(AString)*SizeOf(WideChar));
end;

end.
